////===============================================================================================
//// ļȫжϺ 
////===============================================================================================
#define   __INTERRUPT_GLOBAL
#include  "M451Series.h"
#include  "Interrupt_fun.h"

const uint16_t TabSin[180] = {
        0x000, 0x047, 0x08F, 0x0D6, 0x11E, 0x165, 0x1AC, 0x1F3, 0x23A, 
        0x281, 0x2C7, 0x30E, 0x354, 0x399, 0x3DF, 0x424, 0x469, 0x4AE, 
        0x4F2, 0x536, 0x579, 0x5BC, 0x5FE, 0x640, 0x682, 0x6C3, 0x704, 
        0x744, 0x783, 0x7C2, 0x800, 0x83E, 0x87B, 0x8B7, 0x8F2, 0x92D, 
        0x968, 0x9A1, 0x9DA, 0xA12, 0xA49, 0xA7F, 0xAB5, 0xAE9, 0xB1D, 
        0xB50, 0xB82, 0xBB4, 0xBE4, 0xC13, 0xC42, 0xC6F, 0xC9C, 0xCC7, 
        0xCF2, 0xD1B, 0xD44, 0xD6B, 0xD92, 0xDB7, 0xDDB, 0xDFE, 0xE21, 
        0xE42, 0xE61, 0xE80, 0xE9E, 0xEBA, 0xED6, 0xEF0, 0xF09, 0xF21, 
        0xF38, 0xF4D, 0xF61, 0xF74, 0xF86, 0xF97, 0xFA6, 0xFB5, 0xFC2, 
        0xFCE, 0xFD8, 0xFE1, 0xFEA, 0xFF0, 0xFF6, 0xFFA, 0xFFE, 0xFFF, 
        
       0x1000, 0xFFF, 0xFFE, 0xFFA, 0xFF6, 0xFF0, 0xFEA, 0xFE1, 0xFD8,       
        0xFCE, 0xFC2, 0xFB5, 0xFA6, 0xF97, 0xF86, 0xF74, 0xF61, 0xF4D, 
        0xF38, 0xF21, 0xF09, 0xEF0, 0xED6, 0xEBA, 0xE9E, 0xE80, 0xE61, 
        0xE42, 0xE21, 0xDFE, 0xDDB, 0xDB7, 0xD92, 0xD6B, 0xD44, 0xD1B, 
        0xCF2, 0xCC7, 0xC9C, 0xC6F, 0xC42, 0xC13, 0xBE4, 0xBB4, 0xB82, 
        0xB50, 0xB1D, 0xAE9, 0xAB5, 0xA7F, 0xA49, 0xA12, 0x9DA, 0x9A1, 
        0x968, 0x92D, 0x8F2, 0x8B7, 0x87B, 0x83E, 0x800, 0x7C2, 0x783, 
        0x744, 0x704, 0x6C3, 0x682, 0x640, 0x5FE, 0x5BC, 0x579, 0x536, 
        0x4F2, 0x4AE, 0x469, 0x424, 0x3DF, 0x399, 0x354, 0x30E, 0x2C7, 
        0x281, 0x23A, 0x1F3, 0x1AC, 0x165, 0x11E, 0x0D6, 0x08F, 0x047,        
} ;

//  Hall źŵõתλýǶ ///////////////////////////////////////////////////
void GPA_IRQHandler(void)                                  // PA0_HA, PA1_HB, PA2_HC 
{                                                          // 60Hallź,3,4
  uint32_t const  TabHall[8] = {30<<8,90<<8,330<<8,0,0,150<<8,270<<8,210<<8} ;
  uint32_t static LastHall=3, LastTime = 0 ;                   
  uint32_t  temp32u = PA->PIN & 0x07 ;                     
  
  if(temp32u != LastHall){                                 // ֹ
    HallAngle   = TabHall[temp32u] + 0xC00 ;
    LastHall    = temp32u ;
    temp32u     = (TIMER1->CNT - LastTime) & 0xFFFFFF ;    // ת60ȵʱ
    LastTime    =  TIMER1->CNT  ;                                
    AngleStep   = ((60<<8)*2000/36)/temp32u ;              // PWMƵ36M, Timer1Ƶ1M
    AngleOffset = 0 ;
  }
  PA->INTSRC = 0xFF ;      
}

void PWM0P0_IRQHandler(void)
{
  uint32_t  Angle ;
  int32_t   Duty0, Duty1 ;
                                                           
  if(AngleOffset >= (60<<8)){ 
    AngleOffset -= 60<<8 ;
    HallAngle   += 60<<8 ;
    if(HallAngle >= (360<<8)) HallAngle -= (360<<8) ;
//    if(AngleStep > 7) AngleStep  >>= 1 ;                   // 8λС, 1/32 
  }
  AngleOffset += AngleStep ;  
  Angle = (HallAngle + AngleOffset) >> 8 ;   
  
  if(Angle < 180) Duty1 = -DutyCMR*TabSin[Angle] >> 12 ;   // ֵΪ1000,
  else            Duty1 =  DutyCMR*TabSin[Angle-180] >> 12 ;
  Duty0 = Duty1 >> 1; Duty1 -= Duty0;  //1000,999λֱΪ500,499,-1000,-999λΪ-500                 
  PWM0->CMPDAT0 = 500 + Duty0 ;                            // ʱ,CMPDAT0  CMPDAT1 С 1
  PWM0->CMPDAT1 = 500 + Duty1 ;    

  Angle += 120 ; 	   
  if(Angle >= 360 )Angle -= 360 ;
  if(Angle < 180)  Duty1  = -DutyCMR*TabSin[Angle] >> 12 ;
  else             Duty1  =  DutyCMR*TabSin[Angle-180] >> 12 ;
  Duty0  = Duty1 >> 1 ;   Duty1 -= Duty0 ;
  PWM0->CMPDAT4 = 500 + Duty0 ;   
  PWM0->CMPDAT5 = 500 + Duty1 ;    

  Angle += 120 ; 	   
  if(Angle >= 360 )Angle -= 360 ;
  if(Angle < 180)  Duty1  = -DutyCMR*TabSin[Angle] >> 12 ;
  else             Duty1  =  DutyCMR*TabSin[Angle-180] >> 12 ;
  Duty0  = Duty1 >> 1 ;   Duty1 -= Duty0 ;
  PWM0->CMPDAT2 = 500 + Duty0 ;   
  PWM0->CMPDAT3 = 500 + Duty1 ;    
  
  PWM0->INTSTS0 |= 0x00000100 ;                            // жϱ־ PIF0     
}

void SysTick_Handler(void)
{
  --STick_Int_Cnt ; 
  
//  if((STick_Int_Cnt & 15) == 0){                         // Every 0.01*16 = 0.16s 
//    PD->DOUT |= 0x0020 ;   Led_Flash <<= 1 ;   
//    if(Led_Flash & 0x01000000){ Led_Flash |= 1 ; 
//      PD->DOUT &= ~0x0020 ;  
//    }      
//  }    
}
void I2C0_IRQHandler(void)
{
  uint32_t Status = I2C0->STATUS ;							           // ȶ״ֽ̬

  switch(Status){
  //// ״̬: 꿪ʼ08,ַյACK_18,յACK_28 ///////////////////////  
  case  0x08 :                                             // Start   
    I2C0->CTL &= ~I2C_CTL_STA_Msk ;
    I2C0->CTL |=  I2C_CTL_AA_Msk ;
  case  0x18 :                                             // 豸ַ,յACK
  case  0x28 :                                             // ,յACK
    if(I2C_Buf.NumTx){
      --I2C_Buf.NumTx ;
      I2C0->DAT = *I2C_Buf.pTx++ ;                         // һ
    }
    else I2C0->CTL |= I2C_CTL_STO_Msk ;                    //  STOP, λӲԶ0
    break ; 
  
  //// ״̬: 꿪ʼ08,ַյACK_40, ݷACK_50ACK_58 ////////////  
  case 	0x50 :											                       // յݲACK                               
    *I2C_Buf.pRx++ = I2C0->DAT ;
    if(I2C_Buf.NumRx) --I2C_Buf.NumRx ;
  case  0x40 :                                             // 豸ַ,յACK
    if(I2C_Buf.NumRx <= 1) I2C0->CTL &= ~I2C_CTL_AA_Msk;	 // һ״̬Ϊ0x58
	  break ;
  
  case  0x58 :                                             // һ
    *I2C_Buf.pRx = I2C0->DAT ;
    --I2C_Buf.NumRx ;
  
  //// ,ʧȥٲ //////////////////////////////////////////////////////////////    
  case  0x20 :                                             // 豸ַ, ûյACK
  case  0x30 :                                             // ,ûյACK
  default    :    
    I2C0->CTL |= I2C_CTL_STO_Msk ;                         //  STOP, λӲԶ0
  }
  
  //// ʼһ ///////////////////////////////////////////////////////////////////////
  I2C0->CTL |= I2C_CTL_SI_Msk ;
}
